# for data install in scene 1 - it will create the database, create and upload the login table, create and upload the subject table, and create the marks table

#!/usr/bin/perl
use strict;

&schemaInstall();


sub schemaInstall
{

# call mysql on the server specified by reading the db.conf file

unless(open(DB, "./db.conf"))
	{ die("Cannot open the db.conf file\n"); }
my $line = <DB>;
my %dbConf;
while($line ne "")
	{
	#$line = chomp($line);
	#print $line;
	my @array = split(/=/, $line);
#	print $array[0];
	chomp($array[1]);
	$dbConf{$array[0]} =$array[1];
#	print $dbConf{$array[0]};
	$line = <DB>;
	}

# define the sql commands data file
unless(open(SQL_COMM, ">sql_commands"))
        { die("Could not open the sql_commands file for writing commands\n"); }
      
# define the schema....                                                                                                                       
print SQL_COMM "drop database if exists ".$dbConf{"dbname"}.";\n";
print SQL_COMM "create database ".$dbConf{"dbname"}.";\n";
print SQL_COMM "use ".$dbConf{"dbname"}.";\n";
print SQL_COMM "create table user ( uid int primary key auto_increment, login char(20) unique not null, password char(20), name char(30), submitted int);\n";
print SQL_COMM "create table subject ( sid int primary key auto_increment, value char(20) unique not null);\n";
print SQL_COMM "create table marks (uid int not null, sid int not null, marks int);\n";


# upload the login.txt database with login and password from the login.txt file

unless(open(LOGIN, "login.txt"))
        { die("Login file login.txt not found in current directory.\n"); } 

my $line = <LOGIN>;
$line = <LOGIN>;   	# bypass the first line
my $lineCount = 0;
while($line ne "")
	{
	chomp($line);
	my @fields = split(/\s*\|\s*/, $line);
                                                                               
	$lineCount ++;
	for(my $i = 0; $i < @fields; $i++)
	        {
	        if($fields[$i] ne "")
	                {
	                print SQL_COMM "insert into user (login, password, name, submitted) values (\'".$fields[$i]."\', \'".$fields[$i+1]."\', \'".$fields[$i+2]."\', 0);\n";
			last;
			}
		}
	$line = <LOGIN>;
       	}
close (LOGIN);

# read the first line of data.txt, extract all information about the fields from it , and store them in the subject table
unless(open(DATA, "data.txt"))
	{ die("Data file data.txt not found in current directory.\n"); }


my $firstLine = <DATA>;
my @fields = split(/\s*\|\s*/, $firstLine);
my $count = 1;

for(my $i = 0; $i < @fields; $i++)
	{
	if($fields[$i] ne "" && lc($fields[$i]) ne "login")
		{
		print SQL_COMM "insert into subject (value) values (\'".$fields[$i]."\');\n";
		$count++;
		}
	}
close (DATA);

close(SQL_COMM);



}
